#!/usr/bin/env python


from time import sleep
from time import time
from drive import *
from scan import *


follow_lasttime = None
follow_alpha = 0
follow_distance = 0
follow_times = 0
old_target = None

def follow(target):

  global follow_lasttime
  global old_target

  if follow_lasttime and time() - follow_lasttime < 3:
    return


  if target:
    alpha = target['alpha']
    distance  = target['distance']

    if alpha > 2:
      rotate('right', min(25, alpha), 'grad')
    if alpha < 2:
      rotate('left', min(25, -alpha), 'grad')

    if distance > 20:
      drive('forward', min(15, distance-10), 'cm')
    elif distance < 15:
      drive('backward', min(15, 20-distance), 'cm')
      
    follow_lasttime = time() # now

#----------------------------------#

def main():
  setup_GPIO()
  scan_init()

  first_start = time()
  while True:
    target = scan()
    handleUi()
    if  time()- first_start > 10:
      follow(target)

  cleanup_GPIO()
  scan_cleanup()

#----------------------------------#

if __name__ == "__main__":
  main()
